SetBinding (JavaFX 13)

Module javafx.base
Package javafx.beans.binding

## Class SetBinding<E>

- java.lang.Object
- - javafx.beans.binding.SetExpression<E>
  - - javafx.beans.binding.SetBinding<E>

- Type Parameters:
    `E` - the type of the `Set` elements
  All Implemented Interfaces:
    `Iterable<E>`, `Collection<E>`, `Set<E>`, `Binding<ObservableSet<E>>`, `Observable`, `ObservableObjectValue<ObservableSet<E>>`, `ObservableSetValue<E>`, `ObservableValue<ObservableSet<E>>`, `ObservableSet<E>`

      public abstract class SetBinding<E>
      extends SetExpression<E>
      implements Binding<ObservableSet<E>>

  Base class that provides most of the functionality needed to implement a `Binding` of an `ObservableSet`.

  `SetBinding` provides a simple invalidation-scheme. An extending class can register dependencies by calling `bind(Observable...)`. If one of the registered dependencies becomes invalid, this `SetBinding` is marked as invalid. With `unbind(Observable...)` listening to dependencies can be stopped.

  To provide a concrete implementation of this class, the method `computeValue()` has to be implemented to calculate the value of this binding based on the current state of the dependencies. It is called when `get()` is called for an invalid binding.

  See `DoubleBinding` for an example how this base class can be extended.

  Since:
    JavaFX 2.1
  See Also:
    `Binding`, `SetExpression`

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ReadOnlyBooleanProperty` | `empty` | A boolean property that is `true`, if the set is empty.
    `ReadOnlyIntegerProperty` | `size` | An integer property that represents the size of the set.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SetBinding()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addListener​(InvalidationListener listener)` | Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
    `void` | `addListener​(ChangeListener<? super ObservableSet<E>> listener)` | Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
    `void` | `addListener​(SetChangeListener<? super E> listener)` | Add a listener to this observable set.
    `protected void` | `bind​(Observable... dependencies)` | Start observing the dependencies for changes.
    `protected abstract ObservableSet<E>` | `computeValue()` | Calculates the current value of this binding.
    `void` | `dispose()` | A default implementation of `dispose()` that is empty.
    `ReadOnlyBooleanProperty` | `emptyProperty()` | A boolean property that is `true`, if the set is empty.
    `ObservableSet<E>` | `get()` | Returns the result of `computeValue()`.
    `ObservableList<?>` | `getDependencies()` | A default implementation of `getDependencies()` that returns an empty `ObservableList`.
    `void` | `invalidate()` | Mark a binding as invalid.
    `boolean` | `isValid()` | Checks if a binding is valid.
    `protected void` | `onInvalidating()` | The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid.
    `void` | `removeListener​(InvalidationListener listener)` | Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
    `void` | `removeListener​(ChangeListener<? super ObservableSet<E>> listener)` | Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
    `void` | `removeListener​(SetChangeListener<? super E> listener)` | Tries to removed a listener from this observable set.
    `ReadOnlyIntegerProperty` | `sizeProperty()` | An integer property that represents the size of the set.
    `String` | `toString()` | Returns a string representation of this `SetBinding` object.
    `protected void` | `unbind​(Observable... dependencies)` | Stop observing the dependencies for changes.

    - ### Methods inherited from class javafx.beans.binding.SetExpression

      `add, addAll, asString, clear, contains, containsAll, getSize, getValue, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, remove, removeAll, retainAll, setExpression, size, toArray, toArray`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream, toArray`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `getValue`

    - ### Methods inherited from interface java.util.Set

      `equals, hashCode, spliterator`

- - ### Property Detail

    - #### size

          public ReadOnlyIntegerProperty sizeProperty

      Specified by:
        `sizeProperty` in class `SetExpression<E>`
      See Also:
        `SetExpression.getSize()`

    - #### empty

          public ReadOnlyBooleanProperty emptyProperty

      Specified by:
        `emptyProperty` in class `SetExpression<E>`
      See Also:
        `SetExpression.isEmpty()`

  - ### Constructor Detail

    - #### SetBinding

          public SetBinding()

  - ### Method Detail

    - #### sizeProperty

          public ReadOnlyIntegerProperty sizeProperty()

      Description copied from class: `SetExpression`
      An integer property that represents the size of the set.
      Specified by:
        `sizeProperty` in class `SetExpression<E>`
      See Also:
        `SetExpression.getSize()`

    - #### emptyProperty

          public ReadOnlyBooleanProperty emptyProperty()

      Description copied from class: `SetExpression`
      A boolean property that is `true`, if the set is empty.
      Specified by:
        `emptyProperty` in class `SetExpression<E>`
      See Also:
        `SetExpression.isEmpty()`

    - #### addListener

          public void addListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

      The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

      Specified by:
        `addListener` in interface `Observable`
      Parameters:
        `listener` - The listener to register
      See Also:
        `Observable.removeListener(InvalidationListener)`

    - #### removeListener

          public void removeListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `Observable`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `Observable.addListener(InvalidationListener)`

    - #### addListener

          public void addListener​(ChangeListener<? super ObservableSet<E>> listener)

      Description copied from interface: `ObservableValue`
      Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

      The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

      Specified by:
        `addListener` in interface `ObservableValue<E>`
      Parameters:
        `listener` - The listener to register
      See Also:
        `ObservableValue.removeListener(ChangeListener)`

    - #### removeListener

          public void removeListener​(ChangeListener<? super ObservableSet<E>> listener)

      Description copied from interface: `ObservableValue`
      Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `ObservableValue<E>`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `ObservableValue.addListener(ChangeListener)`

    - #### addListener

          public void addListener​(SetChangeListener<? super E> listener)

      Description copied from interface: `ObservableSet`
      Add a listener to this observable set.
      Specified by:
        `addListener` in interface `ObservableSet<E>`
      Parameters:
        `listener` - the listener for listening to the set changes

    - #### removeListener

          public void removeListener​(SetChangeListener<? super E> listener)

      Description copied from interface: `ObservableSet`
      Tries to removed a listener from this observable set. If the listener is not attached to this list, nothing happens.
      Specified by:
        `removeListener` in interface `ObservableSet<E>`
      Parameters:
        `listener` - a listener to remove

    - #### bind

          protected final void bind​(Observable... dependencies)

      Start observing the dependencies for changes. If the value of one of the dependencies changes, the binding is marked as invalid.
      Parameters:
        `dependencies` - the dependencies to observe

    - #### unbind

          protected final void unbind​(Observable... dependencies)

      Stop observing the dependencies for changes.
      Parameters:
        `dependencies` - the dependencies to stop observing

    - #### dispose

          public void dispose()

      A default implementation of `dispose()` that is empty.
      Specified by:
        `dispose` in interface `Binding<E>`

    - #### getDependencies

          public ObservableList<?> getDependencies()

      A default implementation of `getDependencies()` that returns an empty `ObservableList`.
      Specified by:
        `getDependencies` in interface `Binding<E>`
      Returns:
        an empty `ObservableList`

    - #### get

          public final ObservableSet<E> get()

      Returns the result of `computeValue()`. The method `computeValue()` is only called if the binding is invalid. The result is cached and returned if the binding did not become invalid since the last call of `get()`.
      Specified by:
        `get` in interface `ObservableObjectValue<E>`
      Returns:
        the current value

    - #### onInvalidating

          protected void onInvalidating()

      The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid. The default implementation is empty.

    - #### invalidate

          public final void invalidate()

      Description copied from interface: `Binding`
      Mark a binding as invalid. This forces the recalculation of the value of the `Binding` next time it is request.
      Specified by:
        `invalidate` in interface `Binding<E>`

    - #### isValid

          public final boolean isValid()

      Description copied from interface: `Binding`
      Checks if a binding is valid.
      Specified by:
        `isValid` in interface `Binding<E>`
      Returns:
        `true` if the `Binding` is valid, `false` otherwise

    - #### computeValue

          protected abstract ObservableSet<E> computeValue()

      Calculates the current value of this binding.

      Classes extending `SetBinding` have to provide an implementation of `computeValue`.

      Returns:
        the current value

    - #### toString

          public String toString()

      Returns a string representation of this `SetBinding` object.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of this `SetBinding` object.